<template>
  <div>
    <v-card-text>
      <br>
      <h3 class="black--text text-left font-weight-medium">
        Registro
      </h3>
      <ValidationObserver ref="observer" v-slot="{ handleSubmit, invalid }">
        <v-form @submit.prevent="handleSubmit(register)" class="custom-error">
          <ValidationProvider
              v-slot="{ errors }"
              name="Nombre"
              rules="required"
          >
            <v-text-field
                label="Nombre"
                autocomplete="off"
                type="text"
                name="text"
                v-model="user.name"
                :error-messages="errors"
                append-icon="mdi-account"
            />
          </ValidationProvider>
          <ValidationProvider
              v-slot="{ errors }"
              name="Correo eléctronico"
              rules="required|email"
          >
            <v-text-field
                label="Correo eléctronico"
                autocomplete="off"
                type="email"
                name="text"
                v-model="user.email"
                :error-messages="errors"
                append-icon="mdi-account"
            />
          </ValidationProvider>
          <ValidationProvider
              v-slot="{ errors }"
              name="La contraseña"
              rules="required"
          >
            <v-text-field
                autocomplete="off"
                label="Contraseña"
                type="password"
                name="password"
                v-model="user.password"
                :error-messages="errors"
                append-icon="mdi-key"
            />
          </ValidationProvider>
          <v-card-actions>
            <v-btn block color="info" :loading="loading" :disabled="invalid" type="submit">Registrar</v-btn>
          </v-card-actions>
          <v-btn text @click="$router.push({name:'login'})">¿Ya tienes cuenta?</v-btn>
        </v-form>
      </ValidationObserver>
    </v-card-text>

  </div>
</template>

<script>
import { required, email } from "vee-validate/dist/rules";
import {
  extend,
  ValidationObserver,
  ValidationProvider,
  setInteractionMode,
} from "vee-validate";

setInteractionMode("eager");

extend("required", {
  ...required,
  message: "{_field_} no puede estar vacio.",
});

extend("email", {
  ...email,
  message: "{_field_} no es valído.",
});
export default {
name: "RegisterComponent",
  components:{
  ValidationObserver,
    ValidationProvider
  },
  data:()=>({
    loading:false,
    user:{
      name:'',
      email:'',
      password:''
    }
  }),
  methods:{
    register(){
      this.$http.post('https://gohan-upjhfp6ytq-ue.a.run.app/api/register',this.user).then(res=>{
        console.log(res.data)
      })
    }
  }
}
</script>

<style scoped>

</style>